import Worker from './worker';
import type { FN, Methods, Options, Task } from './types';
declare class WorkTank<MethodName extends string, MethodFunction extends FN> {
    private terminated;
    private terminateTimeout;
    private terminateTimeoutId?;
    private timeout;
    private name;
    private size;
    private methods;
    private tasksBusy;
    private tasksReady;
    private workersBusy;
    private workersReady;
    constructor(options: Options<MethodName, MethodFunction>);
    _autoterminate(): void;
    _getMethods(methods: Methods<MethodName, MethodFunction> | URL | string): string;
    _getTaskReady(): Task<MethodName, MethodFunction> | undefined;
    _getWorkerName(): string;
    _getWorkerReady(): Worker<MethodName, MethodFunction> | undefined;
    exec(method: MethodName, args: Parameters<Methods<MethodName, MethodFunction>[MethodName]>): Promise<Awaited<ReturnType<Methods<MethodName, MethodFunction>[MethodName]>>>;
    terminate(): void;
    tick(): void;
}
export default WorkTank;
